scala

# None

###
Related Doc: package scala

#### object None extends Option[Nothing] with Product with Serializable

This case object represents non-existent values.

Annotations
  @SerialVersionUID()
Source
  Option.scala
Version

  1.0, 16/07/2003

Linear Supertypes
Option[Nothing], Serializable, java.io.Serializable, Product, Equals, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. None
2. Option
3. Serializable
4. Serializable
5. Product
6. Equals
7. AnyRef
8. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class WithFilter extends AnyRef

   We need a whole WithFilter class to honor the "doesn't create a new collection" contract even though it seems unlikely to matter much in a collection with max size 1.

   We need a whole WithFilter class to honor the "doesn't create a new collection" contract even though it seems unlikely to matter much in a collection with max size 1.

   Definition Classes
     Option

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

5. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

6. #### final def collect[B](pf: PartialFunction[Nothing, B]): Option[B]

   Returns a scala.Some containing the result of applying `pf` to this scala.Option's contained value, if this option is nonempty and `pf` is defined for that value.

   Returns a scala.Some containing the result of applying `pf` to this scala.Option's contained value, if this option is nonempty and `pf` is defined for that value. Returns `None` otherwise.

   pf

     the partial function.

   returns

     the result of applying `pf` to this scala.Option's value (if possible), or `None`.

   Definition Classes
     Option
   Annotations
     @inline()
   Example:

   1.     // Returns Some(HTTP) because the partial function covers the case.
          Some("http") collect {case "http" => "HTTP"}

          // Returns None because the partial function doesn't cover the case.
          Some("ftp") collect {case "http" => "HTTP"}

          // Returns None because None is passed to the collect method.
          None collect {case value => value}

7. #### final def contains[A1 >: Nothing](elem: A1): Boolean

   Tests whether the option contains a given value as an element.

   Tests whether the option contains a given value as an element.

   elem

     the element to test.

   returns

     `true` if the option has an element that is equal (as determined by `==`) to `elem`, `false` otherwise.

   Definition Classes
     Option
   Example:

   1.     // Returns true because Some instance contains string "something" which equals "something".
          Some("something") contains "something"

          // Returns false because "something" != "anything".
          Some("something") contains "anything"

          // Returns false when method called on None.
          None contains "anything"

8. #### final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef

9. #### def equals(arg0: Any): Boolean

   The equality method for reference types.

   The equality method for reference types. Default implementation delegates to `eq`.

   See also `equals` in scala.Any.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

10. #### final def exists(p: (Nothing) ⇒ Boolean): Boolean

    Returns true if this option is nonempty and the predicate `p` returns true when applied to this scala.Option's value.

    Returns true if this option is nonempty and the predicate `p` returns true when applied to this scala.Option's value. Otherwise, returns false.

    p

      the predicate to test

    Definition Classes
      Option
    Annotations
      @inline()

11. #### final def filter(p: (Nothing) ⇒ Boolean): Option[Nothing]

    Returns this scala.Option if it is nonempty and applying the predicate `p` to this scala.Option's value returns true.

    Returns this scala.Option if it is nonempty and applying the predicate `p` to this scala.Option's value returns true. Otherwise, return `None`.

    p

      the predicate used for testing.

    Definition Classes
      Option
    Annotations
      @inline()

12. #### final def filterNot(p: (Nothing) ⇒ Boolean): Option[Nothing]

    Returns this scala.Option if it is nonempty and applying the predicate `p` to this scala.Option's value returns false.

    Returns this scala.Option if it is nonempty and applying the predicate `p` to this scala.Option's value returns false. Otherwise, return `None`.

    p

      the predicate used for testing.

    Definition Classes
      Option
    Annotations
      @inline()

13. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

14. #### final def flatMap[B](f: (Nothing) ⇒ Option[B]): Option[B]

    Returns the result of applying `f` to this scala.Option's value if this scala.Option is nonempty.

    Returns the result of applying `f` to this scala.Option's value if this scala.Option is nonempty. Returns `None` if this scala.Option is empty. Slightly different from `map` in that `f` is expected to return an scala.Option (which could be `None`).

    f

      the function to apply

    Definition Classes
      Option
    Annotations
      @inline()
    See also

      foreach

      map

15. #### def flatten[B](implicit ev: <:<[Nothing, Option[B]]): Option[B]

    Definition Classes
      Option

16. #### final def fold[B](ifEmpty: ⇒ B)(f: (Nothing) ⇒ B): B

    Returns the result of applying `f` to this scala.Option's value if the scala.Option is nonempty.

    Returns the result of applying `f` to this scala.Option's value if the scala.Option is nonempty. Otherwise, evaluates expression `ifEmpty`.

    ifEmpty

      the expression to evaluate if empty.

    f

      the function to apply if nonempty.

    Definition Classes
      Option
    Annotations
      @inline()
    Note

      This is equivalent to `scala.Option map f getOrElse ifEmpty`.

17. #### final def forall(p: (Nothing) ⇒ Boolean): Boolean

    Returns true if this option is empty or the predicate `p` returns true when applied to this scala.Option's value.

    Returns true if this option is empty or the predicate `p` returns true when applied to this scala.Option's value.

    p

      the predicate to test

    Definition Classes
      Option
    Annotations
      @inline()

18. #### final def foreach[U](f: (Nothing) ⇒ U): Unit

    Apply the given procedure `f` to the option's value, if it is nonempty.

    Apply the given procedure `f` to the option's value, if it is nonempty. Otherwise, do nothing.

    f

      the procedure to apply.

    Definition Classes
      Option
    Annotations
      @inline()
    See also

      flatMap

      map

19. #### def get: Nothing

    Returns the option's value.

    Returns the option's value.

    Definition Classes
      None → Option
    Exceptions thrown

      `java.util.NoSuchElementException` if the option is empty.

    Note

      The option must be nonEmpty.

20. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

21. #### final def getOrElse[B >: Nothing](default: ⇒ B): B

    Returns the option's value if the option is nonempty, otherwise return the result of evaluating `default`.

    Returns the option's value if the option is nonempty, otherwise return the result of evaluating `default`.

    default

      the default expression.

    Definition Classes
      Option
    Annotations
      @inline()

22. #### def isDefined: Boolean

    Returns true if the option is an instance of scala.Some, false otherwise.

    Returns true if the option is an instance of scala.Some, false otherwise.

    Definition Classes
      Option

23. #### def isEmpty: Boolean

    Returns true if the option is `None`, false otherwise.

    Returns true if the option is `None`, false otherwise.

    Definition Classes
      None → Option

24. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

25. #### def iterator: Iterator[Nothing]

    Returns a singleton iterator returning the scala.Option's value if it is nonempty, or an empty iterator if the option is empty.

    Returns a singleton iterator returning the scala.Option's value if it is nonempty, or an empty iterator if the option is empty.

    Definition Classes
      Option

26. #### final def map[B](f: (Nothing) ⇒ B): Option[B]

    Returns a scala.Some containing the result of applying `f` to this scala.Option's value if this scala.Option is nonempty.

    Returns a scala.Some containing the result of applying `f` to this scala.Option's value if this scala.Option is nonempty. Otherwise return `None`.

    f

      the function to apply

    Definition Classes
      Option
    Annotations
      @inline()
    Note

      This is similar to `flatMap` except here, `f` does not need to wrap its result in an scala.Option.

    See also

      foreach

      flatMap

27. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

28. #### final def nonEmpty: Boolean

    Returns false if the option is `None`, true otherwise.

    Returns false if the option is `None`, true otherwise.

    Definition Classes
      Option
    Note

      Implemented here to avoid the implicit conversion to Iterable.

29. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

30. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

31. #### final def orElse[B >: Nothing](alternative: ⇒ Option[B]): Option[B]

    Returns this scala.Option if it is nonempty, otherwise return the result of evaluating `alternative`.

    Returns this scala.Option if it is nonempty, otherwise return the result of evaluating `alternative`.

    alternative

      the alternative expression.

    Definition Classes
      Option
    Annotations
      @inline()

32. #### final def orNull[A1 >: Nothing](implicit ev: <:<[Null, A1]): A1

    Returns the option's value if it is nonempty, or `null` if it is empty.

    Returns the option's value if it is nonempty, or `null` if it is empty. Although the use of null is discouraged, code written to use scala.Option must often interface with code that expects and returns nulls.

    Definition Classes
      Option
    Annotations
      @inline()
    Example:

    1.     val initialText: Option[String] = getInitialText
           val textField = new JComponent(initialText.orNull,20)

33. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

34. #### final def toLeft[X](right: ⇒ X): Product with Serializable with util.Either[Nothing, X]

    Returns a scala.util.Right containing the given argument `right` if this is empty, or a scala.util.Left containing this scala.Option's value if this scala.Option is nonempty.

    Returns a scala.util.Right containing the given argument `right` if this is empty, or a scala.util.Left containing this scala.Option's value if this scala.Option is nonempty.

    right

      the expression to evaluate and return if this is empty

    Definition Classes
      Option
    Annotations
      @inline()
    See also

      toRight

35. #### def toList: List[Nothing]

    Returns a singleton list containing the scala.Option's value if it is nonempty, or the empty list if the scala.Option is empty.

    Returns a singleton list containing the scala.Option's value if it is nonempty, or the empty list if the scala.Option is empty.

    Definition Classes
      Option

36. #### final def toRight[X](left: ⇒ X): Product with Serializable with util.Either[X, Nothing]

    Returns a scala.util.Left containing the given argument `left` if this scala.Option is empty, or a scala.util.Right containing this scala.Option's value if this is nonempty.

    Returns a scala.util.Left containing the given argument `left` if this scala.Option is empty, or a scala.util.Right containing this scala.Option's value if this is nonempty.

    left

      the expression to evaluate and return if this is empty

    Definition Classes
      Option
    Annotations
      @inline()
    See also

      toLeft

37. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

39. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

40. #### final def withFilter(p: (Nothing) ⇒ Boolean): WithFilter

    Necessary to keep scala.Option from being implicitly converted to scala.collection.Iterable in `for` comprehensions.

    Necessary to keep scala.Option from being implicitly converted to scala.collection.Iterable in `for` comprehensions.

    Definition Classes
      Option
    Annotations
      @inline()

### Inherited from Option[Nothing]

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from AnyRef

### Inherited from Any

### Ungrouped